// Prof Simo - DAINF/UTFPR - Ctba - TecProg S73 - 1 Sem 2025 - 1a Parcial
// Hah couts suplementares para fins de entendimento da execuo.

#include <vector>
#include <iostream>
using namespace std;

namespace agentes
{
    class Agente
    {
        private:
            static int cont_idade ;
            int idade;

        protected:
            virtual void operator++() = 0;

        public:
            Agente(): idade (cont_idade++) { }

            virtual ~Agente() { idade = -1; }

            void setIdade(const int i) { idade = i; }
            const int getIdade() const { return idade; }

            virtual const float getForca() const = 0;

            virtual void agir() = 0;
    };
    int Agente::cont_idade(21);

    class Secreto : public Agente
    {
        private:
            float  forca;

        protected:
            void operator++() { setIdade(getIdade()+1); forca++; }

        public:
            Secreto(const float vez = 0.0) : Agente(), forca((float)getIdade() - vez)
            {
            }

            ~Secreto()
            {
                forca = -1.0;
            }

            void agir()
            {
                operator++();
            }

            const float getForca() const
            {
                return forca;
            }
    };

    class Vetor
    {
        private:
            vector<Agente*> VET;
            Agente*         pAgente;

        public:
            Vetor(Agente* pA = NULL): VET(), pAgente(pA) { VET.clear(); }
            ~Vetor()
            {
                pAgente = NULL;

                vector<Agente*>::const_iterator it;
                it = VET.begin();

                while (it != VET.end())
                {
                    if (*it)
                    {
                        cout << endl << "Deletando agente: " << *it << endl;
                        delete *it;
                    }
                    it++;
                }
                VET.clear();
            }

            void incluir(Agente* pA)
            {
                if (pA)
                {
                    VET.push_back(pA);
                }
                else
                {
                    cout << "Nao se pode incluir nulo em espias!" << endl;
                }
            }

            void percorrer()
            {
                if (pAgente)
                {
                    vector<Agente*>::iterator it;

                    it = VET.begin();

                    while ( it != VET.end() )
                    {

                        if ( *it )
                        {
                            if  (   ( (*it)->getIdade() > 40) ||
                                    ( (*it)->getForca() < pAgente->getForca() )
                                )
                            {
                                delete (*it);
                                VET.erase(it);
                                cout << "Espiao excluindo de Secres: " << *it << endl;
                            }
                            else
                            {
                                (*it)->agir();
                                cout << "Secres agindo: " << *it << endl;
                                it++;
                            }
                        }
                        else
                        {
                            cerr << "Ponteiro nulo em Secres no Vetor!" << endl;
                            it++;
                        }
                    }
                }
                else
                {
                    cerr << "pAgente nulo no Vetor!" << endl;
                }
            }


            const int getTamanho() const { return (int) VET.size(); }
    };

    class Espiao : public Agente
    {
        private:
            Vetor Secres;
            const int forca;

        protected:
            void operator++() { setIdade(getIdade()+1); }

        public:

            Espiao():
                Agente(),
                Secres(static_cast<Agente*>(this)),
                forca(50)
            {
            }

            ~Espiao()
            {
            }


            void incluirSecreto(Secreto* p)
            {
                if (p)
                {
                    Secres.incluir(static_cast<Agente*>(p));
                }
                else
                {
                    cout << "Nao se pode incluir nulo em secres!" << endl;
                }
            }

            const float getForca() const
            {
                return (float)forca;
            }

            void agir()
            {
                operator++();
                Secres.percorrer();
            }

            const int getSecresVivos() const
            {
                return Secres.getTamanho();
            }
    };

class Inteligencia
{
    private:
        Espiao espia1, espia2;

        const int max;

    public:

        Inteligencia() : espia1(), espia2(), max(20)
        {
            criarAgentes();
            executar();
        }

        ~Inteligencia() { }

    private:

        void criarAgentes()
        {
            const int metade = (int)max/2;

            Secreto*    pS = NULL;

            for (int i = 0; i < max; i++)
            {
                pS = NULL;
                pS = new Secreto((float)i+1);

                if (pS)
                {
                    if (i < metade)
                    {
                        espia1.incluirSecreto(pS);
                        //cout << "Agente secreto inserido em Espia1!" << endl;
                    }
                    else
                    {
                        espia2.incluirSecreto(pS);
                        //cout << "Agente secreto inserido em Espia2!" << endl;
                    }
                }
                else
                {
                    cout << "Agente secreto no alocado!" << endl;
                }
            }

        }

        void executar()
        {
            const int metade = (int)max/2;

            espia1.agir();
            espia2.agir();

            cout << "Tamanho em Espia1: " << espia1.getSecresVivos() << endl;
            cout << "Tamanho em Espia2: " << espia2.getSecresVivos() << endl;

            cout << "O total de neutralizados em Espia 1 eh: " << (metade - espia1.getSecresVivos()) << endl;
            cout << "O total de neutralizados em Espia 2 eh: " << (metade - espia2.getSecresVivos()) << endl;
        }
};

} using namespace agentes;

int main ()
{
    //cout << "Funcao main!" << endl;

    Inteligencia intel;

    return 0;
}

